/* jshint esversion : 6 */
const angular_module = require('./module');

angular_module.directive('mdAutocompleteAutofocus', ($timeout) => {
    return {
        restrict: 'A',
        link: (scope, el, attrs) => {

            let input;

            const setAutofocus = () => {
                angular.element(() => {

                    while (!el.find('input') && !el.find('input')[0]) {
                        return;
                    }
                    $timeout(() => {
                        const n = el.find('input');
                        input = n[0];
                        input.focus();
                    }, 0, true);

                });
            }


            scope.$watch(() => scope.$eval(attrs.autofocus), n => {
                if (n)
                    setAutofocus();
            });


        }
    };
});