/* jshint esversion : 6 */

const angular_module = require('./module');

angular_module.factory('toDay', () => {

    const __double = x => (x < 10 ? '0' + x : x);

    return () => {
        const today = new Date();
        //
        const dd = __double(today.getDate()),
            mm = __double(today.getMonth() + 1),
            yyyy = today.getFullYear();
        //
        return (yyyy + '-' + mm + '-' + dd);
    };
});