/* jshint esversion : 6 */
(function dynamicView(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const angular_module = require('./module');
const DynamicItems = require('./dynamicItems');

const DeferredChunkView = function($timeout) {
    return function({ data, chunkSize, pageSize }) {

        const a = data.length ? data.chunk(chunkSize).map(e => {
            return () => {
                const init = e.shit();
                return e.reduce($q.when, $q(init));
            };
        }) : [];


        class DynamicChunk extends DynamicItems {
            constructor(pageSize) {
                super(pageSize);
            }

            fetchPage_(pageNumber) {
                this.loadedPages[pageNumber] = null;

                if (typeof a[pageNumber] === "function") {
                    a[pageNumber]().then(dt => {

                        this.loadedPages[pageNumber] = [];
                        const pageOffset = pageNumber * this.PAGE_SIZE;

                        $timeout(() => this.loadedPages[pageNumber] = dt, 0, true);

                    });
                } else {
                    this.loadedPages[pageNumber] = [];
                    const pageOffset = pageNumber * this.PAGE_SIZE;

                    $timeout(() => this.loadedPages[pageNumber] = [], 0, true);

                }
            }


            fetchNumItems_() {
                this.numItems = data.length;
            }
        }



        return new DynamicChunk(pageSize);

    };
};
DeferredChunkView.$inject = ['$timeout'];
angular_module.factory('deferredChunkView', DeferredChunkView);
},{"./dynamicItems":3,"./module":5}],2:[function(require,module,exports){


const angular_module = require('./module');
const DynamicItems = require('./dynamicItems');

const isObject = x => !Array.isArray(x) && typeof x === 'object';

const DeferredLoadingView = function() {

    return function(data, deferredFn, pageSize) {

        const keys = isObject(data) ? Object.keys(data) : null;

        class DynamicDeferred extends DynamicItems {
            constructor(pageSize) {
                super(pageSize);
            }

            fetchPage_(pageNumber) {
                this.loadedPages[pageNumber] = null;

                (isPromise(deferredFn) ? deferredFn : deferredFn()).then(() => {
                    this.loadedPages[pageNumber] = [];
                    const pageOffset = pageNumber * this.PAGE_SIZE;

                    for (let i = pageOffset; i < pageOffset + this.PAGE_SIZE; i++) {
                        const k = keys ? keys[i] : i;
                        this.loadedPages[pageNumber].push(data[k]);
                    }

                });
            }

            fetchNumItems_() {
                if (Array.isArray(data))
                    this.numItems = data.length;
                else if ("object" === typeof data)
                    this.numItems = Object.keys(data).length;
            }
        }

        return new DynamicDeferred(pageSize);
    };
};


angular_module.factory('deferredLoadingView', DeferredLoadingView);
},{"./dynamicItems":3,"./module":5}],3:[function(require,module,exports){



module.exports = class DynamicItems {
    constructor(pageSize) {
        this.loadedPages = {};

        this.numItems = 0;

        this.PAGE_SIZE = pageSize || 50;

        this.fetchNumItems_();
    }

    getItemAtIndex(index) {
        const pageNumber = Math.floor(index / this.PAGE_SIZE);
        const page = this.loadedPages[pageNumber];

        if (page) {
            return page[index % this.PAGE_SIZE];
        } else if (page !== null) {
            this.fetchPage_(pageNumber);
        }
    }

    getLength() {
        return this.numItems;
    }
};
},{}],4:[function(require,module,exports){



require('./module');
require('./deferredLoadingView');
require('./deferredChunkView');
},{"./deferredChunkView":1,"./deferredLoadingView":2,"./module":5}],5:[function(require,module,exports){
module.exports = angular.module('app_dynamic_view', []);
},{}]},{},[4]);


}());