/* jshint esversion : 6 */


module.exports = (a, size, preserveKey) => {

    const l = a.length;
    const diff = l % size;
    const steps = diff ? ((l - diff) / size + 1) : (l / size);


    const _newArray = new Array(steps);

    for (let i = 0; i < steps; i++)
        _newArray[i] = new Array(
            (diff && i === (steps - 1)) ? diff : size
        );


    let check = 0;
    let step = 0;
    for (let i = 0; i < l; i++) {
        _newArray[step][preserveKey ? i : check] = a[i];
        (check < size - 1) ? check++ : (check = 0, step++);
    }

    return _newArray;

};