/* jshint esversion : 6 */
(function(){

    angular.module('app_modules', ['app_indexed_db', 'app_dynamic_view', 'app_form', 'appIo', 'app_assets', 'fullTextSearch', 'AppManifest']);

    (function assets(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const angular_module = require('./module');
angular_module.filter('capitalize', () => {
    return (txt, s) => txt ? txt.capitalize(s || " ") : txt;
});
},{"./module":6}],2:[function(require,module,exports){

const angular_module = require('./module');

angular_module.factory('$exceptionHandler', ['$log', function($log) {
    return function myExceptionHandler(exception, cause) {
        $log.warn(exception, cause);
    };
}]);
},{"./module":6}],3:[function(require,module,exports){
require('./module');
require('./capitalize');
require('./exceptionHandler');
require('./isIntoView');
require('./smoothIntoView');
require('./mdAutocompleteAutofocus');
require('./toDay');
},{"./capitalize":1,"./exceptionHandler":2,"./isIntoView":4,"./mdAutocompleteAutofocus":5,"./module":6,"./smoothIntoView":7,"./toDay":8}],4:[function(require,module,exports){


const angular_module = require('./module');

angular_module.directive('isIntoView', ($timeout, $document) => {
    return {

        scope: {
            isIntoView: '&'
        },

        link: (scope, element, attrs) => {

            const o = {
                get pageTop() {
                    return window.scrollY;
                },

                get pageBottom() {
                    const pageTop = this.pageTop;
                    return pageTop + (Math.max(document.documentElement.clientHeight, window.innerHeight || 0));
                },

                get elementTop() {
                    const el = element[0];
                    return (el.getBoundingClientRect().top + document.body.scrollTop);
                },

                get elementBottom() {
                    const el = element[0];
                    return (this.elementTop + el.offsetHeight);
                },

                isFullyIntoView(pageTop, pageBottom, elementTop, elementBottom) {
                    if (element)
                        return ((pageTop < elementTop) && (pageBottom > elementBottom));
                    else
                        return false;
                },

                isPartiallyIntoView(pageTop, pageBottom, elementTop, elementBottom) {
                    if (element)
                        return ((elementTop <= pageBottom) && (elementBottom >= pageTop));
                    else
                        return false;
                },

                get isIntoView() {
                    if (element) {
                        const pageTop = this.pageTop;
                        const pageBottom = this.pageBottom;

                        const elementTop = this.elementTop;
                        const elementBottom = this.elementBottom;

                        if (attrs.fullyInView)
                            return this.isFullyIntoView(pageTop, pageBottom, elementTop, elementBottom);
                        else
                            return this.isPartiallyIntoView(pageTop, pageBottom, elementTop, elementBottom);

                    } else
                        return false;

                }
            };



            const scroller = angular.element(document.getElementById('view-scroller'));

            const exec = () => {
                if (o.isIntoView && scope.isIntoView)
                    $timeout(scope.isIntoView, 0);
            };

            scroller.on('scroll', () => exec());

            let executed = 0;

            if (!scope.$eval(attrs.disableIntoViewOnInit)) {
                const delay = scope.$eval(attrs.delay);

                const a = $timeout(() => {
                    let x = scope.$watch(() => o.isIntoView, n => {
                        if (!scope.$eval(attrs.enableRepeat)) {
                            exec();
                            x();
                            $timeout.cancel(a);
                            x = null;
                        }
                    });
                }, delay || 0, true);
            }

        }
    };
});
},{"./module":6}],5:[function(require,module,exports){

const angular_module = require('./module');

angular_module.directive('mdAutocompleteAutofocus', ($timeout) => {
    return {
        restrict: 'A',
        link: (scope, el, attrs) => {

            let input;

            const setAutofocus = () => {
                angular.element(() => {

                    while (!el.find('input') && !el.find('input')[0]) {
                        return;
                    }
                    $timeout(() => {
                        const n = el.find('input');
                        input = n[0];
                        input.focus();
                    }, 0, true);

                });
            }


            scope.$watch(() => scope.$eval(attrs.autofocus), n => {
                if (n)
                    setAutofocus();
            });


        }
    };
});
},{"./module":6}],6:[function(require,module,exports){

module.exports = angular.module('app_assets', []);
},{}],7:[function(require,module,exports){


(function(w, d, undefined) {

    function polyfill() {
        if ('scrollBehavior' in d.documentElement.style)
            return;


        const Element = w.HTMLElement || w.Element,
            SCROLL_TIME = 468;


        let original = {
            scroll: w.scroll || w.scrollTo,
            scrollBy: w.scrollBy,
            elScroll: Element.prototype.scroll || scrollElement,
            scrollIntoView: Element.prototype.scrollIntoView
        };


        let now = w.performance && w.performance.now ?
            w.performance.now.bind(w.performance) : Date.now;

        function scrollElement(x, y) {
            this.scrollLeft = x;
            this.scrollTop = y;
        }

        function ease(k) {
            return 0.5 * (1 - Math.cos(Math.PI * k));
        }

        function shouldBailOut(x) {
            if (typeof x !== 'object' ||
                x === null ||
                x.behavior === undefined ||
                x.behavior === 'auto' ||
                x.behavior === 'instant') {
                return true;
            }

            if (typeof x === 'object' && x.behavior === 'smooth')
                return false;


            throw new TypeError('behavior not valid');
        }

        function findScrollableParent(el) {
            let isBody,
                hasScrollableSpace,
                hasVisibleOverflow;

            do {
                el = el.parentNode;

                isBody = el === d.body;
                hasScrollableSpace = (el.clientHeight < el.scrollHeight || el.clientWidth < el.scrollWidth);
                hasVisibleOverflow = w.getComputedStyle(el, null).overflow === 'visible';
            }
            while (!isBody && !(hasScrollableSpace && !hasVisibleOverflow));

            isBody = hasScrollableSpace = hasVisibleOverflow = null;

            return el;
        }

        function step(context) {
            context.frame = w.requestAnimationFrame(step.bind(w, context));

            let time = now(),
                value,
                currentX,
                currentY,
                elapsed = (time - context.startTime) / SCROLL_TIME;

            elapsed = elapsed > 1 ? 1 : elapsed;

            value = ease(elapsed);

            currentX = context.startX + (context.x - context.startX) * value;
            currentY = context.startY + (context.y - context.startY) * value;

            context.method.call(context.scrollable, currentX, currentY);

            if (currentX === context.x && currentY === context.y) {
                w.cancelAnimationFrame(context.frame);
                return;
            }
        }

        function smoothScroll(el, x, y) {
            let scrollable,
                startX,
                startY,
                method,
                startTime = now(),
                frame;

            if (el === d.body) {
                scrollable = w;
                startX = w.scrollX || w.pageXOffset;
                startY = w.scrollY || w.pageYOffset;
                method = original.scroll;
            } else {
                scrollable = el;
                startX = el.scrollLeft;
                startY = el.scrollTop;
                method = scrollElement;
            }

            if (frame)
                w.cancelAnimationFrame(frame);


            step({
                scrollable: scrollable,
                method: method,
                startTime: startTime,
                startX: startX,
                startY: startY,
                x: x,
                y: y,
                frame: frame
            });
        }


        w.scroll = w.scrollTo = function() {
            if (shouldBailOut(arguments[0])) {
                original.scroll.call(
                    w,
                    arguments[0].left || arguments[0],
                    arguments[0].top || arguments[1]
                );
                return;
            }

            smoothScroll.call(
                w,
                d.body, ~~arguments[0].left, ~~arguments[0].top
            );
        };

        w.scrollBy = function() {
            if (shouldBailOut(arguments[0])) {
                original.scrollBy.call(
                    w,
                    arguments[0].left || arguments[0],
                    arguments[0].top || arguments[1]
                );
                return;
            }

            smoothScroll.call(
                w,
                d.body, ~~arguments[0].left + (w.scrollX || w.pageXOffset), ~~arguments[0].top + (w.scrollY || w.pageYOffset)
            );
        };

        Element.prototype.scroll = Element.prototype.scrollTo = function() {
            if (shouldBailOut(arguments[0])) {
                original.elScroll.call(
                    this,
                    arguments[0].left || arguments[0],
                    arguments[0].top || arguments[1]
                );
                return;
            }

            smoothScroll.call(
                this,
                this,
                arguments[0].left,
                arguments[0].top
            );
        };

        Element.prototype.scrollBy = function() {
            var arg0 = arguments[0];

            if (typeof arg0 === 'object') {
                this.scroll({
                    left: arg0.left + this.scrollLeft,
                    top: arg0.top + this.scrollTop,
                    behavior: arg0.behavior
                });
            } else {
                this.scroll(
                    this.scrollLeft + arg0,
                    this.scrollTop + arguments[1]
                );
            }
        };

        Element.prototype.scrollIntoView = function() {

            if (shouldBailOut(arguments[0])) {
                original.scrollIntoView.call(this, arguments[0] || true);
                return;
            }

            let scrollableParent = findScrollableParent(this);
            let parentRects = scrollableParent.getBoundingClientRect();
            let clientRects = this.getBoundingClientRect();



            if (scrollableParent !== d.body) {
                smoothScroll.call(
                    this,
                    scrollableParent,
                    scrollableParent.scrollLeft + clientRects.left - parentRects.left,
                    scrollableParent.scrollTop + clientRects.top - parentRects.top
                );

                w.scrollBy({
                    left: parentRects.left,
                    top: parentRects.top,
                    behavior: 'smooth'
                });
            } else {

                w.scrollBy({
                    left: clientRects.left,
                    top: clientRects.top,
                    behavior: 'smooth'
                });
            }
        };
    }

    if (typeof exports === 'object') {
        module.exports = { polyfill: polyfill };
    } else {
        polyfill();
    }
})(window, document);

const angular_module = require('./module');
let lastId = null;
angular_module.directive('smoothIntoView', ($timeout) => {
    return {
        link: (scope, elem, attrs) => {

            angular.element(() => {

                const delay = scope.$eval(attrs.delay) || 0;
                const ev = attrs.smoothEvent || 'click';
                const behavior = { behavior: 'smooth' };

                if (attrs.smoothBlock)
                    behavior.block = attrs.smoothBlock;

                const isEnable = () => ('undefined' === typeof scope.$eval(attrs.enableSmooth) ? true : scope.$eval(attrs.enableSmooth));


                let a = scope.$watch(() => isEnable(), enable => {

                    if (enable && lastId != attrs.smoothIntoView) {
                        elem.on(ev, () => {
                            lastId = attrs.smoothIntoView;
                            $timeout(() => {
                                document.getElementById(attrs.smoothIntoView).scrollIntoView(behavior);
                            }, delay, true);
                        });
                    } else
                        elem.off(ev);

                    a();
                    a = null;
                });

            });



        }
    };

});
},{"./module":6}],8:[function(require,module,exports){


const angular_module = require('./module');

angular_module.factory('toDay', () => {

    const __double = x => (x < 10 ? '0' + x : x);

    return () => {
        const today = new Date();
        const dd = __double(today.getDate()),
            mm = __double(today.getMonth() + 1),
            yyyy = today.getFullYear();
        return (yyyy + '-' + mm + '-' + dd);
    };
});
},{"./module":6}]},{},[3]);


}());

(function dynamicView(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const angular_module = require('./module');
const DynamicItems = require('./dynamicItems');

const DeferredChunkView = function($timeout) {
    return function({ data, chunkSize, pageSize }) {

        const a = data.length ? data.chunk(chunkSize).map(e => {
            return () => {
                const init = e.shit();
                return e.reduce($q.when, $q(init));
            };
        }) : [];


        class DynamicChunk extends DynamicItems {
            constructor(pageSize) {
                super(pageSize);
            }

            fetchPage_(pageNumber) {
                this.loadedPages[pageNumber] = null;

                if (typeof a[pageNumber] === "function") {
                    a[pageNumber]().then(dt => {

                        this.loadedPages[pageNumber] = [];
                        const pageOffset = pageNumber * this.PAGE_SIZE;

                        $timeout(() => this.loadedPages[pageNumber] = dt, 0, true);

                    });
                } else {
                    this.loadedPages[pageNumber] = [];
                    const pageOffset = pageNumber * this.PAGE_SIZE;

                    $timeout(() => this.loadedPages[pageNumber] = [], 0, true);

                }
            }


            fetchNumItems_() {
                this.numItems = data.length;
            }
        }



        return new DynamicChunk(pageSize);

    };
};
DeferredChunkView.$inject = ['$timeout'];
angular_module.factory('deferredChunkView', DeferredChunkView);
},{"./dynamicItems":3,"./module":5}],2:[function(require,module,exports){


const angular_module = require('./module');
const DynamicItems = require('./dynamicItems');

const isObject = x => !Array.isArray(x) && typeof x === 'object';

const DeferredLoadingView = function() {

    return function(data, deferredFn, pageSize) {

        const keys = isObject(data) ? Object.keys(data) : null;

        class DynamicDeferred extends DynamicItems {
            constructor(pageSize) {
                super(pageSize);
            }

            fetchPage_(pageNumber) {
                this.loadedPages[pageNumber] = null;

                (isPromise(deferredFn) ? deferredFn : deferredFn()).then(() => {
                    this.loadedPages[pageNumber] = [];
                    const pageOffset = pageNumber * this.PAGE_SIZE;

                    for (let i = pageOffset; i < pageOffset + this.PAGE_SIZE; i++) {
                        const k = keys ? keys[i] : i;
                        this.loadedPages[pageNumber].push(data[k]);
                    }

                });
            }

            fetchNumItems_() {
                if (Array.isArray(data))
                    this.numItems = data.length;
                else if ("object" === typeof data)
                    this.numItems = Object.keys(data).length;
            }
        }

        return new DynamicDeferred(pageSize);
    };
};


angular_module.factory('deferredLoadingView', DeferredLoadingView);
},{"./dynamicItems":3,"./module":5}],3:[function(require,module,exports){



module.exports = class DynamicItems {
    constructor(pageSize) {
        this.loadedPages = {};

        this.numItems = 0;

        this.PAGE_SIZE = pageSize || 50;

        this.fetchNumItems_();
    }

    getItemAtIndex(index) {
        const pageNumber = Math.floor(index / this.PAGE_SIZE);
        const page = this.loadedPages[pageNumber];

        if (page) {
            return page[index % this.PAGE_SIZE];
        } else if (page !== null) {
            this.fetchPage_(pageNumber);
        }
    }

    getLength() {
        return this.numItems;
    }
};
},{}],4:[function(require,module,exports){



require('./module');
require('./deferredLoadingView');
require('./deferredChunkView');
},{"./deferredChunkView":1,"./deferredLoadingView":2,"./module":5}],5:[function(require,module,exports){
module.exports = angular.module('app_dynamic_view', []);
},{}]},{},[4]);


}());

(function formProvider(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const FormField = require('./FormField');

function Form(name, opt) {

    const form = {};
    form.name = name;
    const { title, action, method = "post", bindToForm, enableFlashMessage = true } = opt;
    form.title = title;
    form.action = action;
    form.method = method;
    form.request = { url: action, method: method };
    form.bindToForm = bindToForm;
    form.enableFlashMessage = enableFlashMessage;
    const { successRedirect, failureRedirect } = opt;
    form.succesRedirect = successRedirect;
    form.failureRedirect = failureRedirect;
    const { disableClass = "grey", enableClass = "blue" } = opt;
    form.disableClass = disableClass;
    form.enableClass = enableClass;
    const { disableIconClass = "grey-text", enableIconClass = "green-text" } = opt;
    form.disableIconClass = disableIconClass;
    form.enableIconClass = enableIconClass;
    const { errorIconClass = "red-text", validIconClass = "blue-text" } = opt;
    form.errorIconClass = errorIconClass;
    form.validIconClass = validIconClass;
    form.fields = [];
    form._groups = {};
    form.addField = function(name, opt) {
        if (!opt.group)
            opt.group = "group_" + this.fields.length;

        if (!this._groups[opt.group]) {
            this._groups[opt.group] = { fields: [], order: Object.keys(this._groups).length };
        }

        if (this.fields.indexOf(name) === -1) {
            const f = FormField(name, opt)
            this.fields.push(f);
            this._groups[opt.group].fields.push(f);
        }

        return this;
    }.bind(form);



    return form;
}


module.exports = Form;
},{"./FormField":2}],2:[function(require,module,exports){


const genId = function() {
    let text = "";
    let possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < 10; i++)
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
};

function FormField(name, opt) {
    if (!opt) opt = {};

    const form_field = {};
    form_field.name = name;
    const {
        value = "", type = "text", required = false, label = null, icon = null, group, flex, flexOffset, autocomplete = false, id = genId()
    } = opt;
    form_field.value = value;
    form_field.type = type;
    form_field.required = required;
    form_field.error = {};
    form_field.label = label;
    form_field.icon = icon;
    form_field.group = group;
    form_field.flex = flex;
    form_field.flex_offset = flexOffset;
    form_field.autocomplete = autocomplete;
    form_field.id = id;
    const mq = [
        '-xs', '-gt-xs',
        '-sm', '-gt-sm',
        '-md', '-gt-md',
        '-lg', '-gt-lg', '-xl'
    ];
    mq.map(e => 'flex' + e).forEach(v => form_field[v] = opt[v.replace(/\-/g, '_')] || flex);
    mq.map(e => 'flex_offset' + e).forEach(v => form_field[v] = opt[v.replace(/\-/g, '_')] || flexOffset);
    form_field.validation = (function({ validation, type }) {
        const r = {};

        if (!validation || (type && type === 'number'))
            return "none";
        else if ("string" === typeof validation || RegExp === validation.constructor)
            r.pattern = validation;

        Object.entries(validation).forEach(e => {
            const [k, v] = e;
            r[k] = v;
        });

        return r;
    }(opt));
    form_field.regExp = (function(v) {
        if (v !== 'none')
            return ("string" === typeof v.pattern ? (v.flags ? new RegExp(v.pattern, v.flags) : new RegExp(v.pattern)) : v.pattern);
        else
            return null;
    }(form_field.validation));
    Object.defineProperty(form_field, 'validPattern', {
        get: function() {
            this.error.pattern = false;

            if (this.validation === 'none')
                return true;
            else if (this.value != null && "undefined" !== typeof this.value && this.value.toString().length) {
                this.error.pattern = !this.regExp.test(this.value);
                return !this.error.pattern;
            } else
                return true;
        }
    });
    Object.defineProperty(form_field, 'requiredEditing', {
        get: function() {
            if (this.required && this.value != null && "undefined" !== typeof this.value) {
                this.error.required = this.value.toString().length === 0;
            } else
                this.error.required = false;

            return !this.error.required;
        }
    });
    Object.defineProperty(form_field, 'valid', {
        get: function() {
            return (this.validPattern && this.requiredEditing);
        }
    });
    Object.defineProperty(form_field, '$error', {
        get: function() {
            const a = {};

            const valid = this.valid;

            if (this.value != null && 'undefined' !== typeof this.value && this.value.toString().length)
                this.class = valid ? 'valid' : 'not-valid';

            for (let k in this.error) {
                if (this.error[k]) {
                    a[k] = !valid;
                    if (!valid)
                        this.error[k] = false;
                } else
                    continue;
            }

            return a;
        }
    });


    return form_field;
}

module.exports = FormField;
},{}],3:[function(require,module,exports){


const angular_module = require('./module');
const Form = require('./Form');

const forms = {};
const FormProvider = {
    addForm(name, opt, fn) {

        if (!forms.hasOwnProperty(name))
            forms[name] = Form(name, opt);

        if (fn)
            fn.call(this, forms[name]);

        return this;
    },
    $get($http, $timeout, $location) {
        return name => {


            let flashMessage = null,
                flashMessageCod = null;

            const m = class {
                constructor(name) {
                    angular.extend(this, forms[name]);
                }

                get flashMessage() {
                    return flashMessage;
                }

                get groups() {
                    return Object.values(this._groups).map(e => e.fields)
                }


                sendHttpRequest(fn) {
                    const { request: req, fields } = this;

                    req.data = {};
                    angular.forEach(fields, ({ name, value }, k) => req.data[name] = value);
                    req.transformResponse = (data, headersGetter, status) => {
                        let r;
                        try {
                            r = JSON.parse(data);
                        } catch (e) {
                            r = data;
                        }
                        return r;
                    };

                    if (!fn) {

                        const __locationAssign = (path) => {
                            const a = [
                                ($location.protocol() + '://'), ($location.host() + ':'), $location.port(), (path.match(/^\//) ? path : ('/' + path))
                            ].join("");

                            window.location.assign(a);
                        };


                        const exec = ({ data, status }) => {
                            const { data: res, error, locationRedirect, urlRedirect, hrefRedirect } = data;

                            flashMessage = error ? error : (typeof res === "string" ? res : null);

                            const { failureRedirect, successRedirect } = this;

                            $timeout(() => {
                                if (hrefRedirect) {
                                    window.location.href = hrefRedirect;
                                }
                                if (urlRedirect) {
                                    __locationAssign(urlRedirect);
                                } else if (locationRedirect || failureRedirect || successRedirect) {
                                    if (locationRedirect)
                                        $location.path(locationRedirect);
                                    else
                                        $location.path(error ? failureRedirect : successRedirect);
                                }
                            }, 800, true);

                        };
                        $http(req).then(exec, exec).catch(angular.noop);
                    } else if (typeof fn === "function")
                        $http(req).then(fn, fn).catch(angular.noop);

                }


                get requirementsCompleted() {
                    let r = 1;

                    for (let i = 0; i < this.fields.length; i++) {

                        const { value: v, required } = this.fields[i];

                        if (!required || v !== null && typeof v !== "undefined" && v.toString().length)
                            continue;
                        else {
                            r = 0;
                            break;
                        }
                    }

                    return r;
                }


                get fullyValidated() {
                    let r = 1;
                    for (let i = 0; i < this.fields.length; i++) {
                        if (this.fields[i].valid)
                            continue;
                        else {
                            r = 0;
                            break;
                        }
                    }
                    return r;
                }


                get valid() {
                    return (this.requirementsCompleted && this.fullyValidated);
                }

            };
            return new m(name);
        };
    }
};
angular_module.provider('appForm', FormProvider);
},{"./Form":1,"./module":5}],4:[function(require,module,exports){


require('./module');
require('./FormField');
require('./Form');
require('./FormProvider');
require('./view');
},{"./Form":1,"./FormField":2,"./FormProvider":3,"./module":5,"./view":6}],5:[function(require,module,exports){


module.exports = angular.module('app_form', []);
},{}],6:[function(require,module,exports){


const angular_module = require('./module');

angular_module.directive('appFormAuthInput', () => {
    return {
        restrict: 'A',
        require: ['^^appFormAuthentication', 'ngModel']
    };
});

angular_module.directive('appFormBtn', () => {
    return {
        restrict: 'A',
        require: '^^appFormAuthentication',
        template: '<ng-transclude></ng-transclude>',
        transclude: true,
        scope: {
            sendHttpRequest: '&',
            getFields: '&',
            getFieldsValue: '&'
        },
        link: ($scope, elem, attrs, ctrl) => {

            const { sendHttpRequest, getFields, getFieldsValue } = $scope;

            if (sendHttpRequest) {
                elem.on('click', () => ctrl.sendHttpRequest(sendHttpRequest));
            } else if (getFields) {
                elem.on('click', () => getFields(ctrl.fields));
            } else if (getFieldsValue) {
                elem.on('click', () => getFieldsValue(Object.values(ctrl.fields).map(e => e.value)));
            }
        }
    };
});

angular_module.directive('appFormAuthentication', $timeout => {
    return {
        restrict: 'E',
        controller: ($scope, appForm) => appForm($scope.name),
        controllerAs: '$form',
        scope: {
            name: '@',
            btnTxt: '@?',
            action: '@?',
            method: '@?',
        },
        template: template(),
        transclude: {
            appFormBtn: '?appFormBtn'
        },
        link: (scope, elem, attrs, ctrl) => {

            const form = elem.find('form');

            angular.element(window).on('keyup', ev => {
                if (ev.keyCode === 13 && ctrl.fullyValidated)
                    ctrl.sendHttpRequest();
            });

            if (ctrl.bindToForm) {
                $timeout(() => {
                    form.attr('METHOD', ctrl.method);
                    form.attr('ACTION', ctrl.action);
                }, 0, true);
            }

        }
    };
});


function template() {

    const mq = [
        '-xs', '-gt-xs',
        '-sm', '-gt-sm',
        '-md', '-gt-md',
        '-lg', '-gt-lg', '-xl'
    ];

    let mdInputContainer = '<md-input-container ng-repeat="(k, field) in groups"  flex="{{field.flex}}" flex-offset="{{field.flex_offset}}" ';

    mq.map(e => 'flex' + e).forEach(v => {
        mdInputContainer += v + '="{{field[\'' + v + '\']}}" ';
    });
    mq.map(e => 'flex_offset' + e).forEach(v => {
        mdInputContainer += v + '="{{field[\'' + v + '\']}}" ';
    });

    mdInputContainer += '>';


    return '' +
        '<div layout="row" flex="grow" layout-align="center center">' +
        '   <md-content layout-padding flex>' +
        '       <h1 ng-if="$form.title">{{$form.title}}</h1>' +
        '       <form name="name" layout="column" flex>' +
        '           <div ng-repeat="groups in $form.groups" flex="none" layout="row">' + mdInputContainer +
        '                   <label ng-class="field.class === \'valid\' ? $form.validIconClass : field.class === \'not-valid\' ? $form.errorIconClass : \'\'">{{field.label || field.name}}</label>' +
        '                   <md-icon ng-if="field.icon" ng-bind="field.icon" ng-class="field.class === \'valid\' ? $form.validIconClass : field.class === \'not-valid\' ? $form.errorIconClass : \'\'"></md-icon>' +
        '                   <input app-form-auth-input ng-class="field.class" autocomplete="{{field.autocomplete}}" id="{{field.id}}" type="{{field.type}}" name="{{field.name}}" ng-required="{{field.required}}" ng-model="field.value">' + '</ng-repeat>' +
        '                   <div ng-messages="field.$error" ng-hide="false">' +
        '                       <div ng-message="pattern">{{field.validation.message || \'not valid\'}}</div>' +
        '                   </div>' +
        '               </md-input-container>' +
        '           </div>' +
        '           <div layout="row" flex="none" layout-padding>' +
        '               <div flex="80" ng-if="$form.enableFlashMessage" layout="row">' +
        '                   <div flex layout="row" layout-align="start center" ng-show="$form.flashMessage">' +
        '                       <md-icon ng-bind="\'sentiment_neutral\'"></md-icon>' +
        '                       <div flex="80" layout="row">' +
        '                           <span>{{$form.flashMessage}}</span>' +
        '                       </div>' +
        '                   </div>' +
        '               </div>' +
        '               <div flex="{{$form.enableFlashMessage ? \'20\' : \'auto\'}}" layout="row" layout-align="end center" ng-transclude="appFormBtn">' +
        '                   <md-button ng-if="!$form.bindToForm" aria-label="{{field.name}}" class="md-fab" ng-click="$form.sendHttpRequest()" ng-disabled="!$form.valid" ng-class="!$form.valid ? $form.disableClass : $form.enableClass">' +
        '                       <md-icon ng-bind="\'send\'" ng-class="!$form.valid ? $form.disableIconClass : $form.enableIconClass"></md-icon>' +
        '                   </md-button>' +
        '                   <button type="submit" ng-if="$form.bindToForm" class="md-button md-icon-button" ng-disabled="!$form.valid" ng-class="!$form.valid ? $form.disableClass : $form.enableClass">' +
        '                       <md-icon ng-bind="\'send\'"  ng-class="!$form.valid ? $form.disableIconClass : $form.enableIconClass"></md-icon>' +
        '                   </button>' +
        '               </div>' +
        '           </div>' +
        '       </form>' +
        '   </md-content>' +
        '</div>';
}
},{"./module":5}]},{},[4]);


}());

(function fullTextSearch(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){



module.exports = (a, size, preserveKey) => {

    const l = a.length;
    const diff = l % size;
    const steps = diff ? ((l - diff) / size + 1) : (l / size);


    const _newArray = new Array(steps);

    for (let i = 0; i < steps; i++)
        _newArray[i] = new Array(
            (diff && i === (steps - 1)) ? diff : size
        );


    let check = 0;
    let step = 0;
    for (let i = 0; i < l; i++) {
        _newArray[step][preserveKey ? i : check] = a[i];
        (check < size - 1) ? check++ : (check = 0, step++);
    }

    return _newArray;

};
},{}],2:[function(require,module,exports){


const angular_module = require('./module');
const array_chunk = require('./array_chunk');


class SearchInterval {
    constructor() {
        this.interval = 0;
        this._fn = null;
    }

    set fn(fn) {
        this._fn = fn;
    }

    get fn() {
        return this._fn;
    }

    clearInterval() {
        const q = $q.defer();
        if (this.fn) {
            try {
                this.interval = 0;
                clearInterval(this._fn);
                delete this._fn;
                q.resolve();
            } catch (e) {
                q.reject(e);
            }
        } else
            q.resolve();

        return q.promise;
    }

    setInterval(txt) {
        const q = $q.defer();

        if (!this.fn) {
            this.fn = setInterval(() => {

                this.interval++;
                const y = this.interval % (txt.split(/\s+/g).length + 1);

                if (!y) {
                    this.clearInterval();
                    q.resolve(txt);
                }
            }, 800);
        } else
            q.reject();

        return q.promise;
    }
}

class SearchWorker extends SearchInterval {
    constructor() {
        super();
        this.worker = null;
    }

    setSearchInterval(txt) {
        return this.setInterval(txt).then(txt => this.setWorker(txt));
    }

    terminateWorker() {
        if (this.worker) {
            this.worker.terminate();
            this.worker = null;
        }
        this.clearInterval();
    }

    setWorker(txt) {
        const q = $q.defer();

        if (!txt || !txt.length) {
            this.terminateWorker();
            q.reject();
        } else {
            if (!this.worker) {
                this.worker = new Worker('fuse/fuse.js');
                q.resolve(txt);
            } else
                q.resolve(txt);
        }

        return q.promise;
    }

    postMessage(a) {
        if (this.worker)
            this.worker.postMessage(a);
    }

    set onmessage(fn) {
        if (this.worker)
            this.worker.onmessage = fn;
    }

}


const FullTextSearch = (data, options) => {


    const __searchWorker = new SearchWorker();

    return (txt, ev) => {
        const q = $q.defer();
        __searchWorker.terminateWorker();

        if (!txt || !txt.length)
            q.resolve(data);

        __searchWorker.setWorker(txt)
            .then(
                txt => {

                    __searchWorker.postMessage({ data, options, txt });

                    __searchWorker.onmessage = ({ data: r }) => {
                        __searchWorker.terminateWorker();

                        if (!r || !r.length)
                            q.reject();
                        else
                            q.resolve(r);
                    };
                },
                () => {
                    q.reject();
                    __searchWorker.terminateWorker();
                }
            )
            .catch(() => {
                q.reject();
                __searchWorker.terminateWorker();
            })
            .done();



        return q.promise;
    };
};



const ChunkSearch = function() {
    return function(data, options) {
        if (!options) options = {};


        const __chunk = array_chunk(data, (options.chunkSize || Math.floor(data.length / 10)));
        const queue = __chunk.map(e => FullTextSearch(e, options));

        return (txt, ev) => {
            const q = $q.defer();

            const z = queue.map(e => e(txt, ev));
            const init = z.shift();

            const x = [];

            $q.allSettled(queue.map(e => e(txt, ev)))
                .then(
                    r => {

                        const x = r.reduce((curr, next) => {
                            if (next.state === 'fulfilled')
                                return curr.concat(next.value);

                            return curr;
                        }, []);



                        if (!x.length)
                            q.reject();
                        else {
                            const a = x[0];
                            const isObject = x => !Array.isArray(x) && typeof x === 'object';

                            if (a != null && isObject(a) && a.hasOwnProperty('item'))
                                q.resolve(x.map(e => e.item));
                            else
                                q.resolve(x);
                        }

                    }, q.reject
                )
                .catch(q.reject)
                .done();



            return q.promise;
        };




    };
};


angular_module.factory('fullTextSearch', ChunkSearch);
},{"./array_chunk":1,"./module":5}],3:[function(require,module,exports){


require('./module');
require('./full_text_search');
require('./modal_search');
},{"./full_text_search":2,"./modal_search":4,"./module":5}],4:[function(require,module,exports){


const angular_module = require('./module');

const __modalTemplate = ({ mdDropDownItems, mdClearButton, mdItemText, mdItemLength, placeholder, mdMenuClass, mdMenuContainerClass, mdItemTemplate, titleField, resultPage }) => {
    return (
        '<form ng-submit="$event.preventDefault()" layout="column">' +
        '   <md-autocomplete ' +
        '  ' + (mdDropDownItems ? 'md-dropdown-items="' + mdDropDownItems + '" ' : '') +
        '       md-clear-button="' + mdClearButton + '" ' +
        '       md-autofocus="true" ' +
        '       id="dialog-full-text-autocomplete"  ' +
        '       md-no-cache="false" ' +
        '       md-selected-item="ctrl.selectedItem" ' +
        '       md-search-text-change="ctrl.textChange(ctrl.searchText)" ' +
        '       md-search-text="ctrl.searchText" ' +
        '       md-selected-item-change="ctrl.selectedItemChange(item)" ' +
        '       md-items="item in ctrl.fullTextSearch(ctrl.searchText)" ' +
        '       md-item-text="item[\'' + mdItemText + '\']" ' +
        '       md-min-length="' + mdItemLength + '" ' +
        '       placeholder="' + placeholder + '" ' +
        '  ' + (mdMenuClass ? 'md-menu-class="' + mdMenuClass + '" ' : '') +
        '       ><md-not-found> Nessun risultato per "{{ctrl.searchText}}"</md-not-found>' +
        '  ' + (mdMenuContainerClass ? 'md-menu-container-class="' + mdMenuContainerClass + '" ' : '') + '>' +
        '       <md-item-template>' + (mdItemTemplate ? mdItemTemplate : titleField ? '<span class="item-title"> {{item[\'' + titleField + '\']}} </span>' : "") + '</md-item-template>' +
        '   </md-autocomplete>' +
        '</form>' + (resultPage || "")
    );
};

const DialogFullTextSearch = function($mdDialog) {
    return function(o) {

        if (!o) o = {};
        const {
            title = "Cerca",
                info = "",
                optTopButton1,
                optTopButton2,
                data,
                fullscreen,
                parent = angular.element(document.body),
                clickOutsideToClose,
                dialogClass,
                locals = {},
                onTextChange,
                onSelectedItemChange,
                resultPage,
                mdItemText,
                mdClearButton = true,
                mdDropDownItems,
                mdItemLength = 0,
                placeholder = "",
                mdMenuClass,
                mdMenuContainerClass,
                titleField,
                mdItemTemplate
        } = o;

        const __template = __modalTemplate({
            resultPage,
            mdItemText,
            mdClearButton,
            mdDropDownItems,
            mdItemLength,
            placeholder,
            mdMenuClass,
            mdMenuContainerClass,
            titleField,
            mdItemTemplate
        });


        return {

            show(ev) {
                $mdDialog.show({
                    controller(fullTextSearch, $compile, $scope, $element) {
                        angular.forEach(locals, (v, k) => this[k] = v);
                        this.fullscreen = fullscreen;
                        this.dialogClass = dialogClass;
                        const _fullTextSearh = fullTextSearch(data);
                        this.fullTextSearch = (txt, ev) => {
                            const q = $q.defer();
                            _fullTextSearh(txt, ev).then(q.resolve, q.reject).catch(q.reject).done();
                            return q.promise;
                        };
                        this.hide = () => $mdDialog.hide();
                        this.cancel = () => $mdDialog.cancel();
                        this.title = title;
                        this.info = info;
                        this.optTopButton1 = optTopButton1;
                        this.optTopButton2 = optTopButton2;
                        this.searchText = "";
                        this.selectedItemChange = item => {
                            this.selectedItem = item;
                            return (onSelectedItemChange ? onSelectedItemChange(item) : angular.noop);
                        };
                        this.textChange = item => onTextChange ? onTextChange(item) : angular.noop;


                        $element.find('md-dialog-content').children().append($compile(__template)($scope));

                    },
                    controllerAs: 'ctrl',
                    templateUrl: 'src/app/views/dialog-full-text-search.html',
                    parent: parent,
                    targetEvent: ev,
                    clickOutsideToClose: clickOutsideToClose,
                    fullscreen: fullscreen
                });
            },
            hide() {
                return $mdDialog.hide();
            },
            cancel() {
                return $mdDialog.cancel();
            }

        };


    };
};

DialogFullTextSearch.$inject = ['$mdDialog'];
angular_module.factory('dialogFullTextSearch', DialogFullTextSearch);
},{"./module":5}],5:[function(require,module,exports){
module.exports = angular.module('fullTextSearch', []);
},{}]},{},[3]);


}());

(function app__indexedDb(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const angular_module = require('./module');

const config = {};
const ready = $q.defer();

const $IDB = {
    get ready() { return ready.promise; },

    setDb(dbName, opt) {
        config[dbName] = opt;
        return this;
    },

    run() {

        const setDb = (dbName, opt) => () => $appIDB.setDb(dbName, opt);

        const x = Object.entries(config);
        const [kInit, vInit] = x.shift();

        x.reduce(
                (curr, [k, v], index) => {
                    return curr.then(() => setDb(k, v));
                },
                setDb(kInit, vInit)
            )
            .then(ready.resolve, ready.reject, ready.notify)
            .catch(ready.reject)
            .done();




        return ready.promise;
    },

    useDb(dbName) { return $appIDB.useDb(dbName); },

    $get() { return this; }
};
angular_module.provider('$idb', $IDB);
},{"./module":4}],2:[function(require,module,exports){


const angular_module = require('./module');
const IDB = function($http, IDBStore_setter, $idb) {
    return function(dbName) {

        class Injection {
            constructor($http, IDBStore_setter, $idb) {
                this.$http = $http;
                this.IDBStore_setter = IDBStore_setter;
                this.$idb = $idb;
            }
        }

        class StoresSetter extends Injection {
            constructor($http, IDBStore_setter, $idb) {
                super($http, IDBStore_setter, $idb);
                this.__stores = {};
            }
            _getStore(storeName) {
                return this.__stores[storeName];
            }

            _existStore(storeName) {
                return this.__stores.hasOwnProperty(storeName);
            }

            _addStore(db, dbName, storeName) {
                this.__stores[storeName] = this.IDBStore_setter(db, dbName, storeName);
            }

            _initStore(db, dbName, storeName, httpStatus) {
                if (!this._existStore(storeName))
                    this._addStore(db, dbName, storeName);

                return this._getStore(storeName).onInit(httpStatus);
            }
        }


        const dbReady = $q.defer(),
            ready = $q.defer();

        class IDB extends StoresSetter {
            constructor($http, IDBStore_setter, $idb, dbName) {
                super($http, IDBStore_setter, $idb);
                this.dbName = dbName.capitalize();
            }

            onInit() {
                this.dbReady
                    .then(
                        () => {

                            console.log(this.objectStores)

                            const x = Object.values(this.objectStores)[0];

                            const init = x.shift();

                            x.reduce(
                                    (curr, next, index) => {
                                        return curr
                                            .then(
                                                () => this._setStore(next.name),
                                                ready.reject,
                                                ready.notify
                                            )
                                            .catch(ready.reject);
                                    }, this._setStore(init.name)
                                )
                                .then(ready.resolve, ready.reject, ready.notify)
                                .catch(ready.reject)
                                .done();

                        },
                        ready.reject,
                        ready.notify
                    )
                    .catch(ready.reject)
                    .done();

                return ready.promise;
            }

            get dbReady() {
                return dbReady.promise;
            }

            get ready() {
                return ready.promise;
            }

            _getDBconfig(callback) {
                return this.$http({
                        method: 'POST',
                        url: '/' + this.dbName.toLowerCase() + '/'
                    })
                    .then(callback, callback)
                    .catch(e => angular.noop);
            }

            _setDB() {

                this._getDBconfig(httpRes => {

                    const __dbName = this.dbName.capitalize();
                    const __oldConfig = $localStorage.getItem(__dbName);

                    if (!httpRes || !httpRes.data) httpRes = {};
                    const { status = -1, data = __oldConfig } = httpRes;
                    this.httpStatus = status;

                    this.dbName = data.dbName;

                    this.objectStores = angular.copy(data);

                    if (!__oldConfig) {
                        $localStorage.setItem(__dbName, data);
                    }

                    delete this.objectStores.dbName;

                    ready.notify({ value: { dbName: this.dbName, ev: 'db config' } });

                    if (status === 200 || __oldConfig) {
                        $appIDB.setDb(this.dbName, this.objectStores)
                            .then(
                                () => {
                                    this.db = this.$idb.useDb(this.dbName);
                                    dbReady.resolve();
                                },
                                dbReady.reject,
                                dbReady.notify
                            )
                            .catch(dbReady.reject)
                            .done();

                    } else
                        dbReady.reject();
                });

                return this.dbReady;
            }

            _setStore(storeName) {
                return this._initStore(this.db, this.dbName, storeName, this.httpStatus);
            }

            get allHttpDataLoaded() {
                const httpReady = $q.defer();

                $q.when(this.dbReady,
                        () => {
                            const _stores = Object.values(this.__stores);
                            const queue = _stores.map(e => e.httpRequest);

                            $q.all(queue)
                                .then(httpReady.resolve, httpReady.reject, httpReady.notify)
                                .catch(httpReady.resolve)
                                .done();

                        },
                        httpReady.reject,
                        httpReady.notify
                    )
                    .catch(httpReady.reject)
                    .done();

                return httpReady.promise;
            }


        }

        return new IDB($http, IDBStore_setter, $idb, dbName);
    };
};
IDB.$inject = ['$http', 'IDBStore_setter', '$idb'];
angular_module.service('IDB_setter', IDB);
},{"./module":4}],3:[function(require,module,exports){


require('./module');
require('./idb');
require('./idbSetter');
require('./storeSetter');
require('./setterProvider');
},{"./idb":1,"./idbSetter":2,"./module":4,"./setterProvider":5,"./storeSetter":6}],4:[function(require,module,exports){
module.exports = angular.module('app_indexed_db', []);
},{}],5:[function(require,module,exports){


const angular_module = require('./module');
let _remoteStores = [];
const RemoteDataProvider = {

    pushStores(...a) {
        _remoteStores = Array.from(a);
        return this;
    },

    $get(IDB_setter) {

        const a = {};

        const ___dbsReady = $q.defer(),
            __dataLoaded = $q.defer(),
            ___configReady = $q.defer();


        return {
            run() {

                const exec = e => () => {
                    a[e] = IDB_setter(e);
                    a[e]._setDB();
                    return a[e].dbReady;
                };
                const queue = _remoteStores.map(exec);
                const init = queue.shift();
                queue.reduce(
                        (curr, next, index) => {
                            return curr
                                .then(
                                    () => next(),
                                    ___dbsReady.reject,
                                    ___dbsReady.notify
                                )
                                .catch(___configReady.reject);
                        },
                        init()
                    )
                    .then(___dbsReady.resolve, ___dbsReady.reject, ___dbsReady.notify)
                    .catch(___dbsReady.reject)
                    .done();

                return this;
            },

            get allStores() {
                return a;
            },

            getStore(k) {
                return a[k];
            },

            get ___configReady() {
                $q.when(___dbsReady.promise,
                        () => {
                            const x = Object.values(a);
                            const init = x.shift();


                            x.reduce(
                                    (curr, next, index) => {
                                        return curr
                                            .then(
                                                () => next.onInit(),
                                                ___configReady.reject,
                                                ___configReady.notify
                                            )
                                            .catch(___configReady.reject);
                                    },
                                    init.onInit()
                                )
                                .then(___configReady.resolve, ___configReady.reject, ___configReady.notify)
                                .catch(___configReady.reject)
                                .done();

                        },
                        ___configReady.reject,
                        ___configReady.notify
                    )
                    .catch(___configReady.reject)
                    .done();

                return ___configReady.promise;
            },

            get ready() {

                $q.when(this.___configReady,
                        () => {

                            const queue = Object.values(a).map(e => Object.values(e.__stores).map(s => s.httpRequest));

                            $q.all(queue)
                                .then(__dataLoaded.resolve, __dataLoaded.reject, __dataLoaded.notify)
                                .catch(__dataLoaded.reject)
                                .done();
                        },
                        __dataLoaded.reject,
                        __dataLoaded.notify
                    )
                    .catch(__dataLoaded.reject)
                    .done();

                return __dataLoaded.promise;
            }
        };

    }
};
angular_module.provider('$appRemoteIdb', RemoteDataProvider);
},{"./module":4}],6:[function(require,module,exports){



const angular_module = require('./module');
const IDBStore = function($http, toDay) {
    return function(db, dbName, storeName) {

        class Injection {
            constructor($http, toDay) {
                this.$http = $http;
                this.toDay = toDay;
            }
        }


        const defer = $q.defer();
        class DeferEvents extends Injection {
            constructor($http, toDay) {
                super($http, toDay);
            }
            _notify({ getHttpData, ev, index, dataLength }) {
                const n = {
                    dbName: this.dbName,
                    storeName: this.storeName,
                    getHttpData: getHttpData,
                    ev: ev
                };
                if (index)
                    n.index = index;
                if (dataLength)
                    n.length = dataLength;

                defer.notify(n);
            }

            _resolve(getHttpData) {
                this._notify({
                    ev: getHttpData ? "update ok" : "offline",
                    getHttpData: getHttpData
                });
                return defer.resolve();
            }

            get ready() {
                return defer.promise;
            }
        }


        const httpDefer = $q.defer();
        class IDBStore extends DeferEvents {
            constructor($http, toDay, db, dbName, storeName) {
                super($http, toDay);
                this.objectStore = db.objectStore(storeName);
                this.dbName = dbName.capitalize();
                this.storeName = storeName;
                this.url = '/' + dbName.toLowerCase() + '/' + storeName + '/';
                this._data = [];
                this.offlineDataAvaiable = false;
            }

            onInit(status) {


                const _getStoreData = !this._localParams || this._localParams && this._localParams.lastDataUpdate && this._localParams.lastDataUpdate.date !== this.toDay();


                try {
                    this._getAll()
                        .then(
                            localData => {
                                if (200 !== status || !_getStoreData) {
                                    this._done({ data: localData, getHttpData: 0, lastUpdate: 0 });
                                } else {
                                    this._getStoreData(localData)
                                        .then(
                                            httpRes => {
                                                if (!httpRes) httpRes = {};
                                                const { status = -1, data: remoteData } = httpRes;

                                                if (status !== 200 || !remoteData || !remoteData.length) {
                                                    this._done({ data: localData, getHttpData: 0, lastUpdate: status === 200 });
                                                } else {
                                                    this._updateLocalData({ remoteData: remoteData, localData: localData });
                                                }
                                            },
                                            () => {
                                                this._done({ data: localData, getHttpData: 1, lastUpdate: 0 });
                                            }
                                        );
                                }
                            },
                            err => defer.reject(err)
                        )
                        .catch(err => defer.reject(err))
                        .done();
                } catch (e) {
                    console.log(e);
                }

                return this.ready;
            }

            get httpRequest() {
                return httpDefer.promise;
            }

            set data(dt) {
                this._data = dt;
                this.offlineDataAvaiable = true;
                httpDefer.resolve(dt);
            }

            get data() {
                return this._data;
            }

            get ls_keyName() {
                return ('idb_config_' + this.dbName + '_' + this.storeName);
            }

            get _localParams() {
                return $localStorage.getItem(this.ls_keyName);
            }

            _done({ data, getHttpData, lastUpdate }) {

                this.data = data;


                const ls_store_parameters = this._localParams;


                const cfg = "undefined" !== typeof ls_store_parameters && ls_store_parameters ? ls_store_parameters : {};

                if (!cfg.dateOfCreation)
                    cfg.dateOfCreation = this.toDay();

                const getTime = () => {
                    try {
                        return Date.hasOwnProperty('now') ? Date.now() : new Date().getTime();
                    } catch (e) {
                        return new Date().getTime();
                    }
                }


                if (lastUpdate || !cfg.lastDataUpdate) {
                    cfg.lastDataUpdate = { date: this.toDay() };
                    cfg.lastDataUpdate.time = getTime();
                }

                cfg.lastUpdate = { date: this.toDay(), time: getTime() };


                $localStorage.setItem(this.ls_keyName, cfg);


                this._resolve(getHttpData);

            }

            _getStoreData(dt) {
                const defer = $q.defer();

                this.$http({
                    method: 'POST',
                    url: '/' + this.dbName.toLowerCase() + '/' + this.storeName + '/',
                    cache: true,
                    data: dt,
                    transformResponse: (data, headersGetter, status) => {
                        if ("string" === typeof data)
                            return JSON.parse(data);

                        if (Array.isArray(data) && Array.isArray(data[0]))
                            return data[0];

                        return data;
                    }
                }).then(defer.resolve, defer.reject).catch(e => angular.noop);

                return defer.promise;
            }



            _updateLocalData({ remoteData, localData }) {

                if (!remoteData || !remoteData.length)
                    return this._done({ data: localData, getHttpData: 1, lastUpdate: 1 });

                this.objectStore.bulkUpdate(remoteData,
                    () => {
                        console.log('ok update ' + this.storeName);
                        this._getAll()
                            .then(
                                updateData => {
                                    this._done({ data: updateData, getHttpData: 1, lastUpdate: 1 });
                                },
                                err => {
                                    this._done({ data: localData, getHttpData: 1, lastUpdate: 1 });
                                }
                            )
                            .catch(err => {
                                this._done({ data: localData, getHttpData: 1, lastUpdate: 1 });
                            })
                            .done();
                    },

                    err => {
                        this._done({ data: localData, getHttpData: 1, lastUpdate: 0 });
                    },

                    n => this._notify({
                        'index': n && n.hasOwnProperty('index') ? n.index : null,
                        'getHttpData': true,
                        'dataLength': remoteData && Array.isArray(remoteData) ? remoteData.length : null
                    })

                );


            }

            _getAll() {
                return this.objectStore.getAll();
            }



        }

        return new IDBStore($http, toDay, db, dbName, storeName);
    };
};
IDBStore.$inject = ['$http', 'toDay'];
angular_module.service('IDBStore_setter', IDBStore);
},{"./module":4}]},{},[3]);


}());


(function appIo() {
    const module = angular.module('appIo', []);



    class Network {
        constructor(o) {
            if (!o) o = {};

            const { protocol = "http", address = "127.0.0.1", port = 80, path = "" } = o;
            this.protocol = protocol;
            this.ipAddress = address;
            this.port = port;
            this.path = path;
            this.address = (address + ':' + port);
            this.url = (protocol + '://' + this.address + '/' + path);
        }
    }

    const AppSocket = ($rootScope, $timeout) => {
        return o => {

            let log = true;
            let ready = $q.defer();
            let connectionAttemptNumber = 0;
            let online = true;
            const _setReady = (v, e) => {
                if (e) ready.notify(e);
                ready[v ? 'resolve' : 'reject']();
                $timeout(() => ready = $q.defer(), 600);
            };
            const _broadcastOnlineEvent = b => $rootScope.$emit('socket::connectionEvent', b);

            function SocketEvent(ev) {
                return fn => {
                    this.socket.on(ev, e => {

                        if ("connect" === ev)
                            connectionAttemptNumber = 0;
                        else if (["reconnect", "reconnect_attempt", "reconnecting"].indexOf(ev) > -1)
                            connectionAttemptNumber = e;

                        online = ("connection" === ev || "connect" === ev || "reconnect" === ev);

                        _setReady(e, online);
                        _broadcastOnlineEvent({
                            evName: ev,
                            evDes: e,
                            connected: online
                        });


                        if (fn) fn.call(this, e);

                        if (log) console.log('io::' + ev, e);
                    });
                };
            }
            return (new class AppSocket extends Network {
                constructor({ network, namespace }) {
                    super(network);



                    this.socket = (function(namespace) {
                        let ns = null;
                        if (namespace)
                            ns = (namespace.startsWith('/') ? namespace : ('/' + namespace));

                        return io(ns);
                    }(namespace));

                    const socket_events = [
                        "connect",
                        "connect_error",
                        "connect_timeout",
                        "error",
                        "disconnect",
                        "reconnect",
                        "reconnect_attempt",
                        "reconnect_error",
                        "reconnect_failed",
                    ];
                    socket_events.forEach(v => this["on_" + v] = SocketEvent.call(this, v));

                }

                get connectionAttemptNumber() {
                    return connectionAttemptNumber;
                }
                get online() {
                    return online;
                }

                emit() {
                    const a = Array.from(arguments);
                    this.socket.emit.apply(this.socket, a);
                }
                on(evName, fn) {
                    this.socket.on(evName, res => fn.call(this, res));
                }
                once(evName, fn) {
                    this.socket.once(evName, res => fn.call(this, res));
                }
                hasListeners(evName) {
                    return this.socket.hasListeners(evName);
                }
                removeListener(evName) {
                    this.socket.removeListener(evName);
                }

                ping(fn) {
                    if (fn) {
                        this.socket.on('ping', () => {});
                        this.socket.on('pong', latency => fn.call(this, latency));
                    }
                }
                set enableLog(l) {
                    log = l ? true : false;
                }
                get enableLog() {
                    return log;
                }

            }(o));
        };
    };
    AppSocket.$inject = ['$rootScope', '$timeout'];
    module.factory('appSocket', AppSocket);


    const app_sockets = { cfg: {}, socket: {} };
    const AppIO = {
        addConnection(name, opt) {
            if (!app_sockets.cfg[name])
                app_sockets.cfg[name] = opt || null;

            return this;
        },
        $get(appSocket) {
            return n => {
                if (!app_sockets.socket[n])
                    app_sockets.socket[n] = appSocket(app_sockets.cfg[n]);

                return app_sockets.socket[n];
            };
        }
    };
    module.provider('appIo', AppIO);

}());


(function appManifest() {

    const module = angular.module('AppManifest', []);


    function AppManifest() {

        let isUpdated = false;

        const cache = window.applicationCache;
        const ready = $q.defer();

        const o = Object.create({});

        Object.defineProperty(o, 'status', {
            get: () => {
                const status = cache.status;

                if (cache.UNCACHED == status) 
                    return 'UNCACHED';
                else if (cache.IDLE == status) 
                    return 'IDLE';
                else if (cache.CHECKING == status) 
                    return 'CHECKING';
                else if (cache.DOWNLOADING == status) 
                    return 'DOWNLOADING';
                else if (cache.UPDATEREADY == status) 
                    return 'UPDATEREADY';
                else if (cache.OBSOLETE == status) 
                    return 'OBSOLETE';
                else
                    return 'UKNOWN CACHE STATUS';
            }
        });

        const evs = ['cached', 'checking', 'downloading', 'error', 'noupdate', 'obsolete', 'progress', 'updateready'];
        evs.forEach(ev => {
            const onEv = 'on' + ev;
            Object.defineProperty(o, onEv, {
                value: fn => {
                    if (fn) {
                        cache[onEv] = () => fn.call(this);
                        cache.addEventListener(ev, e => fn.call(this, e), false);
                    }
                }
            });
        });

        Object.defineProperty(o, 'isUpdated', { get: () => isUpdated });

        Object.defineProperty(o, 'run', {
            value: function() {

                const setReady = () => {
                    ready.notify(cache);



                    if (!isUpdated)
                        isUpdated = (cache.status === 4 || cache.status === 3);


                    if ([1, 4].indexOf(cache.status) > -1)
                        ready.resolve(this.status);
                };

                const setError = e => {
                    console.warn(e);
                    ready.reject(e);
                };

                evs.forEach(ev => {
                    const onEv = 'on' + ev;
                    this[onEv](e => ev == 'error' ? setError(e) : setReady());
                });

                try {
                    cache.update(); 
                } catch (e) {
                    ready.notify(e);
                }


            }
        });

        Object.defineProperty(o, 'ready', { get: () => ready.promise });

        o.run();

        return o;
    }
    module.factory('appManifest', AppManifest);

}());

}());