/* jshint esversion : 6 */

const angular_module = require('./module');
let _remoteStores = [];
const RemoteDataProvider = {

    pushStores(...a) {
        _remoteStores = Array.from(a);
        return this;
    },

    $get(IDB_setter) {

        const a = {};

        const ___dbsReady = $q.defer(),
            __dataLoaded = $q.defer(),
            ___configReady = $q.defer();


        return {
            run() {

                const exec = e => () => {
                    a[e] = IDB_setter(e);
                    a[e]._setDB();
                    return a[e].dbReady;
                };
                const queue = _remoteStores.map(exec);
                const init = queue.shift();
                queue.reduce(
                        (curr, next, index) => {
                            return curr
                                .then(
                                    () => next(),
                                    ___dbsReady.reject,
                                    ___dbsReady.notify
                                )
                                .catch(___configReady.reject);
                        },
                        init()
                    )
                    .then(___dbsReady.resolve, ___dbsReady.reject, ___dbsReady.notify)
                    .catch(___dbsReady.reject)
                    .done();

                /*  $q.all(queue)
                    .then(___dbsReady.resolve, ___dbsReady.reject, ___dbsReady.notify)
                    .catch(___dbsReady.reject)
                    .done();
*/
                return this;
            },

            get allStores() {
                return a;
            },

            getStore(k) {
                return a[k];
            },

            get ___configReady() {
                $q.when(___dbsReady.promise,
                        () => {
                            const x = Object.values(a);
                            const init = x.shift();


                            x.reduce(
                                    (curr, next, index) => {
                                        return curr
                                            .then(
                                                () => next.onInit(),
                                                ___configReady.reject,
                                                ___configReady.notify
                                            )
                                            .catch(___configReady.reject);
                                    },
                                    init.onInit()
                                )
                                .then(___configReady.resolve, ___configReady.reject, ___configReady.notify)
                                .catch(___configReady.reject)
                                .done();

                            /* const queue = Object.values(a).map(e => {
                                e.onInit();
                                return e.ready;
                            });
                            $q.all(queue)
                                .then(___configReady.resolve, ___configReady.reject, ___configReady.notify)
                                .catch(___configReady.reject)
                                .done(); */
                        },
                        ___configReady.reject,
                        ___configReady.notify
                    )
                    .catch(___configReady.reject)
                    .done();

                return ___configReady.promise;
            },

            get ready() {

                $q.when(this.___configReady,
                        () => {

                            const queue = Object.values(a).map(e => Object.values(e.__stores).map(s => s.httpRequest));

                            $q.all(queue)
                                .then(__dataLoaded.resolve, __dataLoaded.reject, __dataLoaded.notify)
                                .catch(__dataLoaded.reject)
                                .done();
                        },
                        __dataLoaded.reject,
                        __dataLoaded.notify
                    )
                    .catch(__dataLoaded.reject)
                    .done();

                return __dataLoaded.promise;
            }
        };

    }
};
angular_module.provider('$appRemoteIdb', RemoteDataProvider);