/* jshint esversion : 6 */
(function assets(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const angular_module = require('./module');
angular_module.filter('capitalize', () => {
    return (txt, s) => txt ? txt.capitalize(s || " ") : txt;
});
},{"./module":6}],2:[function(require,module,exports){

const angular_module = require('./module');

angular_module.factory('$exceptionHandler', ['$log', function($log) {
    return function myExceptionHandler(exception, cause) {
        $log.warn(exception, cause);
    };
}]);
},{"./module":6}],3:[function(require,module,exports){
require('./module');
require('./capitalize');
require('./exceptionHandler');
require('./isIntoView');
require('./smoothIntoView');
require('./mdAutocompleteAutofocus');
require('./toDay');
},{"./capitalize":1,"./exceptionHandler":2,"./isIntoView":4,"./mdAutocompleteAutofocus":5,"./module":6,"./smoothIntoView":7,"./toDay":8}],4:[function(require,module,exports){


const angular_module = require('./module');

angular_module.directive('isIntoView', ($timeout, $document) => {
    return {

        scope: {
            isIntoView: '&'
        },

        link: (scope, element, attrs) => {

            const o = {
                get pageTop() {
                    return window.scrollY;
                },

                get pageBottom() {
                    const pageTop = this.pageTop;
                    return pageTop + (Math.max(document.documentElement.clientHeight, window.innerHeight || 0));
                },

                get elementTop() {
                    const el = element[0];
                    return (el.getBoundingClientRect().top + document.body.scrollTop);
                },

                get elementBottom() {
                    const el = element[0];
                    return (this.elementTop + el.offsetHeight);
                },

                isFullyIntoView(pageTop, pageBottom, elementTop, elementBottom) {
                    if (element)
                        return ((pageTop < elementTop) && (pageBottom > elementBottom));
                    else
                        return false;
                },

                isPartiallyIntoView(pageTop, pageBottom, elementTop, elementBottom) {
                    if (element)
                        return ((elementTop <= pageBottom) && (elementBottom >= pageTop));
                    else
                        return false;
                },

                get isIntoView() {
                    if (element) {
                        const pageTop = this.pageTop;
                        const pageBottom = this.pageBottom;

                        const elementTop = this.elementTop;
                        const elementBottom = this.elementBottom;

                        if (attrs.fullyInView)
                            return this.isFullyIntoView(pageTop, pageBottom, elementTop, elementBottom);
                        else
                            return this.isPartiallyIntoView(pageTop, pageBottom, elementTop, elementBottom);

                    } else
                        return false;

                }
            };



            const scroller = angular.element(document.getElementById('view-scroller'));

            const exec = () => {
                if (o.isIntoView && scope.isIntoView)
                    $timeout(scope.isIntoView, 0);
            };

            scroller.on('scroll', () => exec());

            let executed = 0;

            if (!scope.$eval(attrs.disableIntoViewOnInit)) {
                const delay = scope.$eval(attrs.delay);

                const a = $timeout(() => {
                    let x = scope.$watch(() => o.isIntoView, n => {
                        if (!scope.$eval(attrs.enableRepeat)) {
                            exec();
                            x();
                            $timeout.cancel(a);
                            x = null;
                        }
                    });
                }, delay || 0, true);
            }

        }
    };
});
},{"./module":6}],5:[function(require,module,exports){

const angular_module = require('./module');

angular_module.directive('mdAutocompleteAutofocus', ($timeout) => {
    return {
        restrict: 'A',
        link: (scope, el, attrs) => {

            let input;

            const setAutofocus = () => {
                angular.element(() => {

                    while (!el.find('input') && !el.find('input')[0]) {
                        return;
                    }
                    $timeout(() => {
                        const n = el.find('input');
                        input = n[0];
                        input.focus();
                    }, 0, true);

                });
            }


            scope.$watch(() => scope.$eval(attrs.autofocus), n => {
                if (n)
                    setAutofocus();
            });


        }
    };
});
},{"./module":6}],6:[function(require,module,exports){

module.exports = angular.module('app_assets', []);
},{}],7:[function(require,module,exports){


(function(w, d, undefined) {

    function polyfill() {
        if ('scrollBehavior' in d.documentElement.style)
            return;


        const Element = w.HTMLElement || w.Element,
            SCROLL_TIME = 468;


        let original = {
            scroll: w.scroll || w.scrollTo,
            scrollBy: w.scrollBy,
            elScroll: Element.prototype.scroll || scrollElement,
            scrollIntoView: Element.prototype.scrollIntoView
        };


        let now = w.performance && w.performance.now ?
            w.performance.now.bind(w.performance) : Date.now;

        function scrollElement(x, y) {
            this.scrollLeft = x;
            this.scrollTop = y;
        }

        function ease(k) {
            return 0.5 * (1 - Math.cos(Math.PI * k));
        }

        function shouldBailOut(x) {
            if (typeof x !== 'object' ||
                x === null ||
                x.behavior === undefined ||
                x.behavior === 'auto' ||
                x.behavior === 'instant') {
                return true;
            }

            if (typeof x === 'object' && x.behavior === 'smooth')
                return false;


            throw new TypeError('behavior not valid');
        }

        function findScrollableParent(el) {
            let isBody,
                hasScrollableSpace,
                hasVisibleOverflow;

            do {
                el = el.parentNode;

                isBody = el === d.body;
                hasScrollableSpace = (el.clientHeight < el.scrollHeight || el.clientWidth < el.scrollWidth);
                hasVisibleOverflow = w.getComputedStyle(el, null).overflow === 'visible';
            }
            while (!isBody && !(hasScrollableSpace && !hasVisibleOverflow));

            isBody = hasScrollableSpace = hasVisibleOverflow = null;

            return el;
        }

        function step(context) {
            context.frame = w.requestAnimationFrame(step.bind(w, context));

            let time = now(),
                value,
                currentX,
                currentY,
                elapsed = (time - context.startTime) / SCROLL_TIME;

            elapsed = elapsed > 1 ? 1 : elapsed;

            value = ease(elapsed);

            currentX = context.startX + (context.x - context.startX) * value;
            currentY = context.startY + (context.y - context.startY) * value;

            context.method.call(context.scrollable, currentX, currentY);

            if (currentX === context.x && currentY === context.y) {
                w.cancelAnimationFrame(context.frame);
                return;
            }
        }

        function smoothScroll(el, x, y) {
            let scrollable,
                startX,
                startY,
                method,
                startTime = now(),
                frame;

            if (el === d.body) {
                scrollable = w;
                startX = w.scrollX || w.pageXOffset;
                startY = w.scrollY || w.pageYOffset;
                method = original.scroll;
            } else {
                scrollable = el;
                startX = el.scrollLeft;
                startY = el.scrollTop;
                method = scrollElement;
            }

            if (frame)
                w.cancelAnimationFrame(frame);


            step({
                scrollable: scrollable,
                method: method,
                startTime: startTime,
                startX: startX,
                startY: startY,
                x: x,
                y: y,
                frame: frame
            });
        }


        w.scroll = w.scrollTo = function() {
            if (shouldBailOut(arguments[0])) {
                original.scroll.call(
                    w,
                    arguments[0].left || arguments[0],
                    arguments[0].top || arguments[1]
                );
                return;
            }

            smoothScroll.call(
                w,
                d.body, ~~arguments[0].left, ~~arguments[0].top
            );
        };

        w.scrollBy = function() {
            if (shouldBailOut(arguments[0])) {
                original.scrollBy.call(
                    w,
                    arguments[0].left || arguments[0],
                    arguments[0].top || arguments[1]
                );
                return;
            }

            smoothScroll.call(
                w,
                d.body, ~~arguments[0].left + (w.scrollX || w.pageXOffset), ~~arguments[0].top + (w.scrollY || w.pageYOffset)
            );
        };

        Element.prototype.scroll = Element.prototype.scrollTo = function() {
            if (shouldBailOut(arguments[0])) {
                original.elScroll.call(
                    this,
                    arguments[0].left || arguments[0],
                    arguments[0].top || arguments[1]
                );
                return;
            }

            smoothScroll.call(
                this,
                this,
                arguments[0].left,
                arguments[0].top
            );
        };

        Element.prototype.scrollBy = function() {
            var arg0 = arguments[0];

            if (typeof arg0 === 'object') {
                this.scroll({
                    left: arg0.left + this.scrollLeft,
                    top: arg0.top + this.scrollTop,
                    behavior: arg0.behavior
                });
            } else {
                this.scroll(
                    this.scrollLeft + arg0,
                    this.scrollTop + arguments[1]
                );
            }
        };

        Element.prototype.scrollIntoView = function() {

            if (shouldBailOut(arguments[0])) {
                original.scrollIntoView.call(this, arguments[0] || true);
                return;
            }

            let scrollableParent = findScrollableParent(this);
            let parentRects = scrollableParent.getBoundingClientRect();
            let clientRects = this.getBoundingClientRect();



            if (scrollableParent !== d.body) {
                smoothScroll.call(
                    this,
                    scrollableParent,
                    scrollableParent.scrollLeft + clientRects.left - parentRects.left,
                    scrollableParent.scrollTop + clientRects.top - parentRects.top
                );

                w.scrollBy({
                    left: parentRects.left,
                    top: parentRects.top,
                    behavior: 'smooth'
                });
            } else {

                w.scrollBy({
                    left: clientRects.left,
                    top: clientRects.top,
                    behavior: 'smooth'
                });
            }
        };
    }

    if (typeof exports === 'object') {
        module.exports = { polyfill: polyfill };
    } else {
        polyfill();
    }
})(window, document);

const angular_module = require('./module');
let lastId = null;
angular_module.directive('smoothIntoView', ($timeout) => {
    return {
        link: (scope, elem, attrs) => {

            angular.element(() => {

                const delay = scope.$eval(attrs.delay) || 0;
                const ev = attrs.smoothEvent || 'click';
                const behavior = { behavior: 'smooth' };

                if (attrs.smoothBlock)
                    behavior.block = attrs.smoothBlock;

                const isEnable = () => ('undefined' === typeof scope.$eval(attrs.enableSmooth) ? true : scope.$eval(attrs.enableSmooth));


                let a = scope.$watch(() => isEnable(), enable => {

                    if (enable && lastId != attrs.smoothIntoView) {
                        elem.on(ev, () => {
                            lastId = attrs.smoothIntoView;
                            $timeout(() => {
                                document.getElementById(attrs.smoothIntoView).scrollIntoView(behavior);
                            }, delay, true);
                        });
                    } else
                        elem.off(ev);

                    a();
                    a = null;
                });

            });



        }
    };

});
},{"./module":6}],8:[function(require,module,exports){


const angular_module = require('./module');

angular_module.factory('toDay', () => {

    const __double = x => (x < 10 ? '0' + x : x);

    return () => {
        const today = new Date();
        const dd = __double(today.getDate()),
            mm = __double(today.getMonth() + 1),
            yyyy = today.getFullYear();
        return (yyyy + '-' + mm + '-' + dd);
    };
});
},{"./module":6}]},{},[3]);


}());