/* jshint esversion : 6 */

const angular_module = require('./module');
const DynamicItems = require('./dynamicItems');

const DeferredChunkView = function($timeout) {
    return function({ data, chunkSize, pageSize }) {

        const a = data.length ? data.chunk(chunkSize).map(e => {
            return () => {
                const init = e.shit();
                return e.reduce($q.when, $q(init));
            };
        }) : [];


        class DynamicChunk extends DynamicItems {
            constructor(pageSize) {
                super(pageSize);
            }

            fetchPage_(pageNumber) {
                this.loadedPages[pageNumber] = null;

                if (typeof a[pageNumber] === "function") {
                    a[pageNumber]().then(dt => {

                        this.loadedPages[pageNumber] = [];
                        const pageOffset = pageNumber * this.PAGE_SIZE;

                        $timeout(() => this.loadedPages[pageNumber] = dt, 0, true);

                    });
                } else {
                    this.loadedPages[pageNumber] = [];
                    const pageOffset = pageNumber * this.PAGE_SIZE;

                    $timeout(() => this.loadedPages[pageNumber] = [], 0, true);

                }
            }


            fetchNumItems_() {
                this.numItems = data.length;
            }
        }



        return new DynamicChunk(pageSize);

    };
};
DeferredChunkView.$inject = ['$timeout'];
angular_module.factory('deferredChunkView', DeferredChunkView);