/* jshint esversion : 6 */

const { gulp, babelify, browserify, buffer, source, strip, wrap } = require('../gulp_plugins');



const __build_full_text_search = () => {
    const src = `${__dirname}/src/index.js`;
    const bundler = browserify(src);
    //bundler.transform(babelify, { presets: ["@babel/preset-env"] });

    return bundler.bundle()
        .on('error', function(err) { console.error(err); })
        .pipe(source('index.js'))
        .pipe(buffer())
        .pipe(strip())
        .pipe(wrap({ src: `${__dirname}/wrap.txt` }))
        .pipe(gulp.dest(__dirname));
};


exports.full_text_search = __build_full_text_search;
/* gulp.task('full_text_search', __build_full_text_search); */