/* jshint esversion : 6 */
(function app__indexedDb(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const angular_module = require('./module');

const config = {};
const ready = $q.defer();

const $IDB = {
    get ready() { return ready.promise; },

    setDb(dbName, opt) {
        config[dbName] = opt;
        return this;
    },

    run() {

        const setDb = (dbName, opt) => () => $appIDB.setDb(dbName, opt);

        const x = Object.entries(config);
        const [kInit, vInit] = x.shift();

        x.reduce(
                (curr, [k, v], index) => {
                    return curr.then(() => setDb(k, v));
                },
                setDb(kInit, vInit)
            )
            .then(ready.resolve, ready.reject, ready.notify)
            .catch(ready.reject)
            .done();




        return ready.promise;
    },

    useDb(dbName) { return $appIDB.useDb(dbName); },

    $get() { return this; }
};
angular_module.provider('$idb', $IDB);
},{"./module":4}],2:[function(require,module,exports){


const angular_module = require('./module');
const IDB = function($http, IDBStore_setter, $idb) {
    return function(dbName) {

        class Injection {
            constructor($http, IDBStore_setter, $idb) {
                this.$http = $http;
                this.IDBStore_setter = IDBStore_setter;
                this.$idb = $idb;
            }
        }

        class StoresSetter extends Injection {
            constructor($http, IDBStore_setter, $idb) {
                super($http, IDBStore_setter, $idb);
                this.__stores = {};
            }
            _getStore(storeName) {
                return this.__stores[storeName];
            }

            _existStore(storeName) {
                return this.__stores.hasOwnProperty(storeName);
            }

            _addStore(db, dbName, storeName) {
                this.__stores[storeName] = this.IDBStore_setter(db, dbName, storeName);
            }

            _initStore(db, dbName, storeName, httpStatus) {
                if (!this._existStore(storeName))
                    this._addStore(db, dbName, storeName);

                return this._getStore(storeName).onInit(httpStatus);
            }
        }


        const dbReady = $q.defer(),
            ready = $q.defer();

        class IDB extends StoresSetter {
            constructor($http, IDBStore_setter, $idb, dbName) {
                super($http, IDBStore_setter, $idb);
                this.dbName = dbName.capitalize();
            }

            onInit() {
                this.dbReady
                    .then(
                        () => {

                            console.log(this.objectStores)

                            const x = Object.values(this.objectStores)[0];

                            const init = x.shift();

                            x.reduce(
                                    (curr, next, index) => {
                                        return curr
                                            .then(
                                                () => this._setStore(next.name),
                                                ready.reject,
                                                ready.notify
                                            )
                                            .catch(ready.reject);
                                    }, this._setStore(init.name)
                                )
                                .then(ready.resolve, ready.reject, ready.notify)
                                .catch(ready.reject)
                                .done();

                        },
                        ready.reject,
                        ready.notify
                    )
                    .catch(ready.reject)
                    .done();

                return ready.promise;
            }

            get dbReady() {
                return dbReady.promise;
            }

            get ready() {
                return ready.promise;
            }

            _getDBconfig(callback) {
                return this.$http({
                        method: 'POST',
                        url: '/' + this.dbName.toLowerCase() + '/'
                    })
                    .then(callback, callback)
                    .catch(e => angular.noop);
            }

            _setDB() {

                this._getDBconfig(httpRes => {

                    const __dbName = this.dbName.capitalize();
                    const __oldConfig = $localStorage.getItem(__dbName);

                    if (!httpRes || !httpRes.data) httpRes = {};
                    const { status = -1, data = __oldConfig } = httpRes;
                    this.httpStatus = status;

                    this.dbName = data.dbName;

                    this.objectStores = angular.copy(data);

                    if (!__oldConfig) {
                        $localStorage.setItem(__dbName, data);
                    }

                    delete this.objectStores.dbName;

                    ready.notify({ value: { dbName: this.dbName, ev: 'db config' } });

                    if (status === 200 || __oldConfig) {
                        $appIDB.setDb(this.dbName, this.objectStores)
                            .then(
                                () => {
                                    this.db = this.$idb.useDb(this.dbName);
                                    dbReady.resolve();
                                },
                                dbReady.reject,
                                dbReady.notify
                            )
                            .catch(dbReady.reject)
                            .done();

                    } else
                        dbReady.reject();
                });

                return this.dbReady;
            }

            _setStore(storeName) {
                return this._initStore(this.db, this.dbName, storeName, this.httpStatus);
            }

            get allHttpDataLoaded() {
                const httpReady = $q.defer();

                $q.when(this.dbReady,
                        () => {
                            const _stores = Object.values(this.__stores);
                            const queue = _stores.map(e => e.httpRequest);

                            $q.all(queue)
                                .then(httpReady.resolve, httpReady.reject, httpReady.notify)
                                .catch(httpReady.resolve)
                                .done();

                        },
                        httpReady.reject,
                        httpReady.notify
                    )
                    .catch(httpReady.reject)
                    .done();

                return httpReady.promise;
            }


        }

        return new IDB($http, IDBStore_setter, $idb, dbName);
    };
};
IDB.$inject = ['$http', 'IDBStore_setter', '$idb'];
angular_module.service('IDB_setter', IDB);
},{"./module":4}],3:[function(require,module,exports){


require('./module');
require('./idb');
require('./idbSetter');
require('./storeSetter');
require('./setterProvider');
},{"./idb":1,"./idbSetter":2,"./module":4,"./setterProvider":5,"./storeSetter":6}],4:[function(require,module,exports){
module.exports = angular.module('app_indexed_db', []);
},{}],5:[function(require,module,exports){


const angular_module = require('./module');
let _remoteStores = [];
const RemoteDataProvider = {

    pushStores(...a) {
        _remoteStores = Array.from(a);
        return this;
    },

    $get(IDB_setter) {

        const a = {};

        const ___dbsReady = $q.defer(),
            __dataLoaded = $q.defer(),
            ___configReady = $q.defer();


        return {
            run() {

                const exec = e => () => {
                    a[e] = IDB_setter(e);
                    a[e]._setDB();
                    return a[e].dbReady;
                };
                const queue = _remoteStores.map(exec);
                const init = queue.shift();
                queue.reduce(
                        (curr, next, index) => {
                            return curr
                                .then(
                                    () => next(),
                                    ___dbsReady.reject,
                                    ___dbsReady.notify
                                )
                                .catch(___configReady.reject);
                        },
                        init()
                    )
                    .then(___dbsReady.resolve, ___dbsReady.reject, ___dbsReady.notify)
                    .catch(___dbsReady.reject)
                    .done();

                return this;
            },

            get allStores() {
                return a;
            },

            getStore(k) {
                return a[k];
            },

            get ___configReady() {
                $q.when(___dbsReady.promise,
                        () => {
                            const x = Object.values(a);
                            const init = x.shift();


                            x.reduce(
                                    (curr, next, index) => {
                                        return curr
                                            .then(
                                                () => next.onInit(),
                                                ___configReady.reject,
                                                ___configReady.notify
                                            )
                                            .catch(___configReady.reject);
                                    },
                                    init.onInit()
                                )
                                .then(___configReady.resolve, ___configReady.reject, ___configReady.notify)
                                .catch(___configReady.reject)
                                .done();

                        },
                        ___configReady.reject,
                        ___configReady.notify
                    )
                    .catch(___configReady.reject)
                    .done();

                return ___configReady.promise;
            },

            get ready() {

                $q.when(this.___configReady,
                        () => {

                            const queue = Object.values(a).map(e => Object.values(e.__stores).map(s => s.httpRequest));

                            $q.all(queue)
                                .then(__dataLoaded.resolve, __dataLoaded.reject, __dataLoaded.notify)
                                .catch(__dataLoaded.reject)
                                .done();
                        },
                        __dataLoaded.reject,
                        __dataLoaded.notify
                    )
                    .catch(__dataLoaded.reject)
                    .done();

                return __dataLoaded.promise;
            }
        };

    }
};
angular_module.provider('$appRemoteIdb', RemoteDataProvider);
},{"./module":4}],6:[function(require,module,exports){



const angular_module = require('./module');
const IDBStore = function($http, toDay) {
    return function(db, dbName, storeName) {

        class Injection {
            constructor($http, toDay) {
                this.$http = $http;
                this.toDay = toDay;
            }
        }


        const defer = $q.defer();
        class DeferEvents extends Injection {
            constructor($http, toDay) {
                super($http, toDay);
            }
            _notify({ getHttpData, ev, index, dataLength }) {
                const n = {
                    dbName: this.dbName,
                    storeName: this.storeName,
                    getHttpData: getHttpData,
                    ev: ev
                };
                if (index)
                    n.index = index;
                if (dataLength)
                    n.length = dataLength;

                defer.notify(n);
            }

            _resolve(getHttpData) {
                this._notify({
                    ev: getHttpData ? "update ok" : "offline",
                    getHttpData: getHttpData
                });
                return defer.resolve();
            }

            get ready() {
                return defer.promise;
            }
        }


        const httpDefer = $q.defer();
        class IDBStore extends DeferEvents {
            constructor($http, toDay, db, dbName, storeName) {
                super($http, toDay);
                this.objectStore = db.objectStore(storeName);
                this.dbName = dbName.capitalize();
                this.storeName = storeName;
                this.url = '/' + dbName.toLowerCase() + '/' + storeName + '/';
                this._data = [];
                this.offlineDataAvaiable = false;
            }

            onInit(status) {


                const _getStoreData = !this._localParams || this._localParams && this._localParams.lastDataUpdate && this._localParams.lastDataUpdate.date !== this.toDay();


                try {
                    this._getAll()
                        .then(
                            localData => {
                                if (200 !== status || !_getStoreData) {
                                    this._done({ data: localData, getHttpData: 0, lastUpdate: 0 });
                                } else {
                                    this._getStoreData(localData)
                                        .then(
                                            httpRes => {
                                                if (!httpRes) httpRes = {};
                                                const { status = -1, data: remoteData } = httpRes;

                                                if (status !== 200 || !remoteData || !remoteData.length) {
                                                    this._done({ data: localData, getHttpData: 0, lastUpdate: status === 200 });
                                                } else {
                                                    this._updateLocalData({ remoteData: remoteData, localData: localData });
                                                }
                                            },
                                            () => {
                                                this._done({ data: localData, getHttpData: 1, lastUpdate: 0 });
                                            }
                                        );
                                }
                            },
                            err => defer.reject(err)
                        )
                        .catch(err => defer.reject(err))
                        .done();
                } catch (e) {
                    console.log(e);
                }

                return this.ready;
            }

            get httpRequest() {
                return httpDefer.promise;
            }

            set data(dt) {
                this._data = dt;
                this.offlineDataAvaiable = true;
                httpDefer.resolve(dt);
            }

            get data() {
                return this._data;
            }

            get ls_keyName() {
                return ('idb_config_' + this.dbName + '_' + this.storeName);
            }

            get _localParams() {
                return $localStorage.getItem(this.ls_keyName);
            }

            _done({ data, getHttpData, lastUpdate }) {

                this.data = data;


                const ls_store_parameters = this._localParams;


                const cfg = "undefined" !== typeof ls_store_parameters && ls_store_parameters ? ls_store_parameters : {};

                if (!cfg.dateOfCreation)
                    cfg.dateOfCreation = this.toDay();

                const getTime = () => {
                    try {
                        return Date.hasOwnProperty('now') ? Date.now() : new Date().getTime();
                    } catch (e) {
                        return new Date().getTime();
                    }
                }


                if (lastUpdate || !cfg.lastDataUpdate) {
                    cfg.lastDataUpdate = { date: this.toDay() };
                    cfg.lastDataUpdate.time = getTime();
                }

                cfg.lastUpdate = { date: this.toDay(), time: getTime() };


                $localStorage.setItem(this.ls_keyName, cfg);


                this._resolve(getHttpData);

            }

            _getStoreData(dt) {
                const defer = $q.defer();

                this.$http({
                    method: 'POST',
                    url: '/' + this.dbName.toLowerCase() + '/' + this.storeName + '/',
                    cache: true,
                    data: dt,
                    transformResponse: (data, headersGetter, status) => {
                        if ("string" === typeof data)
                            return JSON.parse(data);

                        if (Array.isArray(data) && Array.isArray(data[0]))
                            return data[0];

                        return data;
                    }
                }).then(defer.resolve, defer.reject).catch(e => angular.noop);

                return defer.promise;
            }



            _updateLocalData({ remoteData, localData }) {

                if (!remoteData || !remoteData.length)
                    return this._done({ data: localData, getHttpData: 1, lastUpdate: 1 });

                this.objectStore.bulkUpdate(remoteData,
                    () => {
                        console.log('ok update ' + this.storeName);
                        this._getAll()
                            .then(
                                updateData => {
                                    this._done({ data: updateData, getHttpData: 1, lastUpdate: 1 });
                                },
                                err => {
                                    this._done({ data: localData, getHttpData: 1, lastUpdate: 1 });
                                }
                            )
                            .catch(err => {
                                this._done({ data: localData, getHttpData: 1, lastUpdate: 1 });
                            })
                            .done();
                    },

                    err => {
                        this._done({ data: localData, getHttpData: 1, lastUpdate: 0 });
                    },

                    n => this._notify({
                        'index': n && n.hasOwnProperty('index') ? n.index : null,
                        'getHttpData': true,
                        'dataLength': remoteData && Array.isArray(remoteData) ? remoteData.length : null
                    })

                );


            }

            _getAll() {
                return this.objectStore.getAll();
            }



        }

        return new IDBStore($http, toDay, db, dbName, storeName);
    };
};
IDBStore.$inject = ['$http', 'toDay'];
angular_module.service('IDBStore_setter', IDBStore);
},{"./module":4}]},{},[3]);


}());